/*****************************************************************************/
/*
                                  langdef.h

Language defintion file containing a global storage array of pointers to the
message names that should exist in the message files.  This needs to be updated
whenever a message 

  1)  is added to the code and language files
  2)  name is changed in the code and language files
  3)  is deleted from the code and language files

It does NOT NEED TO BE ALTERED when the text of one of those messages is
altered in any or all of the language files.

This is only used to verify the language file if there is a discrepancy in the
number of messages between the definition below and the number dynamically
loaded.

27-FEB-2007  MGD  add "compose_save_last",
                      "folder_dest",
                      "folder_cannot",
                      "folder_draft_items",
                      "folder_waste_items",
                      "login_authentication_failure",
                      "login_confirm_logout",
                      "login_cookie_absent",
                      "login_credentials_incomplete",
                      "login_credentials_invalid",
                      "login_failure_count",
                      "login_idle_session",
                      "login_logout",
                      "mail_file_deleted",
                      "option_soy_draft_items"
                      "option_soy_message_order",
                      "option_soy_message_order_more",
                      "option_soy_message_order_less",
                      "option_soy_quote_forward",
                      "option_soy_sent_items",
                      "option_soy_waste_items",
                      "sent"
                  modify "folder_empty" to "folder_notexist",
                         "option_soy_quote_char" to "option_soy_quote_reply"
                  remove "folder_soy_waste" (superceded "folder_waste_items"),
                         "folder_soy_temp"
27-JUN-2006  MGD  add "about_disk_quota", "disk_quota_used",
                      "attach_extract_part", "attach_extract_done",
                      "option_soy_sigfile",
                      "option_soy_sigfile_default",
                      "option_soy_sigfile_soymail",
                      "option_soy_sigfile_none"
                  remove "vms_foreign", "compose_edit_normal",
                         "compose_edit_wide"
                  modify "option_vms_sigfile" to "option_sigfile",
                         "option_vms_sigfile_save" to "option_sigfile_save"
18-JUN-2006  MGD  add "contact_reset" and "contact_reset_confirm"
26-APR-2006  MGD  add "reply_to"
04-APR-2006  MGD  add "compose_send_close"
30-MAR-2006  MGD  initial
*/
/*****************************************************************************/

#define LANG_MANDATORY "en"
#define LANG_MSG_TOTAL 278

char *LangDefList [LANG_MSG_TOTAL+1] =
{

"lang_name",
"lang_author",
"lang_charset",

"greeting",

"about",
"about_soymail",
"about_version",
"about_environment",
"about_server",
"about_client",
"about_forwarded",
"about_agent",
"about_disk_quota",
"about_site",
"about_info",

"all",
"all_messages",

"attach_file",
"attach_delete",
"attach_delete_done",
"attach_delete_all",
"attach_extract_part",
"attach_extract_done",
"attach_message",
"attach_save_part",
"attach_save_done",
"attach_upload_done",
"attach_none_supplied",

"bcc",

"cc",
"check_newmail_in",
"checking_newmail",
"close",

"compose",
"compose_a_reply",
"compose_a_forward",
"compose_add",
"compose_add_none",
"compose_bcc",
"compose_bcc_self",
"compose_bcc_vms_address",
"compose_button_width",
"compose_cc",
"compose_cc_self",
"compose_clear",
"compose_clear_confirm",
"compose_clear_done",
"compose_edit_html",
"compose_edit_plain",
"compose_either_or",
"compose_new",
"compose_new_confirm",
"compose_new_done",
"compose_no_recipient",
"compose_no_subject",
"compose_no_text",
"compose_reply_to",
"compose_reply_to_vms_address",
"compose_reset",
"compose_reset_confirm",
"compose_restore",
"compose_restore_confirm",
"compose_restore_done",
"compose_save",
"compose_save_draft",
"compose_save_last",
"compose_send",
"compose_send_close",
"compose_sign",
"compose_sign_done",
"compose_to",
"compose_sent_ok",
"compose_quote",
"compose_original",
"compose_already_sent",
"compose_wrap_on",
"compose_wrap_off",

"contacts",
"contact_added",
"contact_email",
"contact_delete",
"contact_edit",
"contact_entry",
"contact_export",
"contact_fax",
"contact_import",
"contact_imported",
"contact_loaded",
"contact_merge",
"contact_merged",
"contact_mobile",
"contact_personal",
"contact_phone",
"contact_postal",
"contact_postal_street",
"contact_postal_city",
"contact_postal_state",
"contact_postal_code",
"contact_postal_country",
"contact_reset",
"contact_reset_confirm",
"contact_save",
"contact_saved",
"contact_self",

"copy",

"date",
"delete",
"dest_not_specified",
"disabled",
"disk_quota_used",
"duration",

"edit_as_new",
"enabled",
"empty",

"file_format_error",
"file_too_large",
"file_wrong_type",

"folder_at",
"folder_cannot",
"folder_dest",
"folder_draft_items",
"folder_notexist",
"folder_opened",
"folder_same",
"folder_select",
"folder_waste_items",

"forward",
"from",

"header",
"help",

"listen",
"listen_not_supported",

"login_authentication_failure",
"login_confirm_logout",
"login_cookie_absent",
"login_credentials_incomplete",
"login_credentials_invalid",
"login_failure_count",
"login_idle_session",
"login_logout",

"logout",
"logout_confirm",
"logout_not",
"logout_disabled",

"mail_file_deleted",

"message",
"message_attachments",
"message_add_contact",
"message_add_contact_name",
"message_checksum",
"message_html_to_plain",
"message_opened",
"message_parts",
"message_read_html",
"message_read_plain",
"message_massage_on",
"message_massage_off",

"mime_type_unknown",
"mime_parse_error",
"mime_part",
"minutes",
"most_recent",
"move",
"msgs_copied",
"msgs_deleted",
"msgs_moved",

"new",
"n_e_w_m_a_i_l",
"next",
"no_more_messages",
"none_selected",
"(none)",
"not_applicable",

"open",

"options",
"option_soy_apply",
"option_soy_check_new",
"option_soy_compose_HTML",
"option_soy_draft_items",
"option_soy_folder_buttons",
"option_soy_font_family",
"option_soy_font_size",
"option_soy_lang",
"option_soy_link_URL",
"option_soy_massage",
"option_soy_message_order",
"option_soy_message_order_more",
"option_soy_message_order_less",
"option_soy_name",
"option_soy_per_page",
"option_soy_read_preference",
"option_soy_read_plain1_html0",
"option_soy_read_plain1_html2",
"option_soy_read_plain2_html1",
"option_soy_read_history",
"option_soy_read_history_aster",
"option_soy_read_history_number",
"option_soy_quote_forward",
"option_soy_quote_reply",
"option_soy_sent_items",
"option_soy_sigfile",
"option_soy_sigfile_default",
"option_soy_sigfile_soymail",
"option_soy_sigfile_none",
"option_soy_smtpfrom",
"option_soy_restore",
"option_soy_save",
"option_soy_theme",
"option_soy_use_only_MAIL",
"option_soy_you_got_mail",
"option_soy_you_got_mail_personal",
"option_soy_you_got_mail_file_too_large",
"option_soy_waste_items",

"option_vms_autopurge",
"option_vms_ccprompt",
"option_vms_copyfwd",
"option_vms_copyreply",
"option_vms_copysend",
"option_vms_editor",
"option_vms_forwarding",
"option_vms_personalname",
"option_vms_printqueue",
"option_vms_printform",
"option_vms_save",
"option_vms_signature",

"option_saved",
"option_sigfile",
"option_sigfile_save",

"part_not_found",
"page_opened",
"prev",
"print",

"range",
"raw",
"regex_disabled",
"regex_expression",
"requires_javascript",
"reset",

"reply",
"reply_all",
"reply_to",
"received",
"reload",

"sanity_check",
"sent",

"search",
"search_any",
"search_attachment",
"search_begin",
"search_clear",
"search_category",
"search_cat_html",
"search_cat_plain",
"search_cat_raw",
"search_cat_rfc",
"search_cat_with_att",
"search_cat_without_att",
"search_cat_vms",
"search_date",
"search_date_before",
"search_date_since",
"search_date_on",
"search_disabled",
"search_hits",
"search_message",
"search_new",
"search_results",
"search_searched",
"search_parameters",

"subject",
"sure?",

"to",

"unimplemented",
"view",
"waste",
"working_on_it",

"weekdays",
"months",

NULL

};

/*****************************************************************************/
