/******************************************************************************/
/*
                                  options.h
*/
/******************************************************************************/

#ifndef INCLUDE_OPTIONS_H
#define INCLUDE_OPTIONS_H

/***********/
/* defines */
/***********/

#define OPTIONS_CHECK_NEW 15
#define OPTIONS_FONT_SIZE 10
#define OPTIONS_ITEMS_PER_PAGE 10
#define OPTIONS_LANGUAGE "en"
#define OPTIONS_PER_PAGE 20
#define OPTIONS_QUOTE_FORWARD ""
#define OPTIONS_QUOTE_REPLY "> "
#define OPTIONS_THEME "default"
#define OPTIONS_WRAP_AT 78

/* show messages read history with asterisk */
#define OPTIONS_READ_HISTORY_ASTER  1
/* show messages read history with negative number */
#define OPTIONS_READ_HISTORY_NUMBER 2

/* message read preferences */
#define OPTIONS_READ_PLAIN1_HTML0 10
#define OPTIONS_READ_PLAIN1_HTML2 12
#define OPTIONS_READ_PLAIN2_HTML1 21
/* only used to 'probe' whether an HTML alternative is present! */
#define OPTIONS_READ_PLAIN0_HTML1 01

/* signature file options */
#define OPTIONS_SOY_SIGFILE_DEFAULT   0
#define OPTIONS_SOY_SIGFILE_SOYMAIL   1
#define OPTIONS_SOY_SIGFILE_NONE    999

/**************/
/* prototypes */
/**************/

void OptionsLoadSoy (REQUEST_DATA*);
void OptionsPage (REQUEST_DATA*);
void OptionsParse (USER_OPTIONS*, char*);
BOOL OptionsPageRequest (REQUEST_DATA*);
void OptionsPublicGet (REQUEST_DATA*);
void OptionsPersonalYouGotMail (REQUEST_DATA*);
int OptionsSelectFile (char*, char*, char*);
void OptionsSigFile (REQUEST_DATA*, char*);
void OptionsSigFileLoad (REQUEST_DATA*);
void OptionsSigFileSave (REQUEST_DATA*);
void OptionsSoyApplySave (REQUEST_DATA*, BOOL);
void OptionsSoyMail (REQUEST_DATA*);
void OptionsVms (REQUEST_DATA*);
void OptionsVmsSave (REQUEST_DATA*);
void OptionsWithinReason (USER_OPTIONS*);

#endif /* INCLUDE_OPTIONS_H */

/******************************************************************************/

