/*****************************************************************************/
/*
                                  soyMAIL.c

                         ~ Son Of YahMAIL (ta da!) ~


COPYRIGHT
---------
Copyright (C) 2005-2007 Mark G.Daniel
This program, comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it
under the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.


VERSION HISTORY
---------------
26-MAR-2007  MGD  v1.3.2,
                  bugfix; autogenous login with OSU
                  bugfix; CgiLibOsuInit() <DNETHDR> no URL-decode
24-MAR-2007  MGD  v1.3.1,
                  AttachComposeList() JavaScript-enable the [attach] button
                  AttachUpload() massage MSIE filenames with full path
                    (fixes checkbox CHECKEDing when MSIE uploading attachments)
                  bugfix; RequestVmsMailContext() establishes file/folder 
                    context (fixes issue with folder button functionality)
16-MAR-2007  MGD  v1.3.0,
                  soyMAIL autogenous authentication and logout
                  multiple Mail file [copy][move] destination selectors
                     provide all files (drawers) and associated folders 
                  MessageBodyButtons() rearrange [delete][waste] buttons
                    to be that same order as MessagePageFolderRequest()
                  CallMailFileClose() enforce full-close purge of WASTEBASKET
                  CallMailDestFolderList() list all folders in all mail files
                  CallMailMessageDelete() now checks non-MAIL.MAI mail files
                    and deletes them if empty (contain no folders)
                  AttachComposeList() checkbox to 'delete all attachments'
                    after a successful message send 
                  ComposeSendMessage() if 'delete all attachments' checkbox 
                    delete all attachments after successful send
                  SearchGetString() modify to allow significant spaces
                  NewMailScriptRefresh() and NewMailScriptAjax() cater
                    for MSIE initial IFRAME load to avoid disruptive
                    initial 'check new mail' message in status panel
                  specially process PMDF IMAP folder subdirectories
                    see CallMailPmdfImapFolder() for explanation
                  [message-attachment-panel] is a manual option that positions
                    attachment panel above or below (default) the message body
                  [draft-items] user option for specify name of drafts folder
                  [sent-items] user option for automatically saving sent items
                  [waste-items] user option for specifying [waste] folder
                  Purveyor has been explicitly excluded because of issues
                    with it's CGI <stdout> IPC mailbox overflowing at 1024
                    characters and this generating spurious newlines with
                    "text/.." response MIME types
                  bugfix; MessageAttachments() perform URL_ENCODE() rather
                    than HTML_ESCAPE() on buttons for message attachment URLs
                  bugfix; MimeDecParseBody() add MimeDecProcessPart() to
                    message/rfc822 processing to cope with content encoding
                  bugfix; InetMailParseField() handling continuation
                   line after <CR><LF> carriage-control ("Snt Items")
30-JUL-2006  MGD  v1.2.2,
                  bugfix; CerealDataOut() perhaps those ambits were not the
                    the issue, set a minimum buffer space of 256 (to catch
                    possible zero-length data streams that still need a hash)
22-JUL-2006  MGD  v1.2.1,
                  rework reply-all address compilation
                  try to make font width allowances for monospace
                  add [message-order] user option directive
                  AddressListMassage() allow for comma-separated addresses
                  MessageFolderList() user-optional message ordering
                  PublicMessageFolderList() user-optional message ordering
                  bugfix; ContactsLdifRecord() HTML-escape only non-base64
                  bugfix; ComposePage() HTML-escape the hidden signature
                  bugfix; ComposeTextMassage() retain quote-char as a string
                  bugfix; ComposeSendMessage() check reply-to for VMS address
                    (Non- info-WASD subscribers are lucky to have info-WASD
                    subscribers get all of my stupid errors winnowed-out
                    before public release.)
12-JUL-2006  MGD  v1.2.0,
                  ComposeCopySelf() to refine interactions between VMS mail
                    addresses, [smtp-default-host], and copy-self, etc.
                  add [forward]ing (from message read page) of attachments
                    with ComposeReplyAttachList(), ComposeForwardAttachList()
                    and changes to ComposeMime() to add the forwarded parts
                  AttachFileExtract() to extract message parts as
                    user-accessable files into the user home directory
                  CallMailUserDiskQuota() and MessageDiskQuotaUsed() notifies
                    the client with each folder open once disk quota reaches
                    the percentage specified by default (85%) ro configuration
                  HelpAbout() adds a disk quota report item
                  ComposeRfcDate() to derive RFC822 "Date:" from client via
                    JavaScript to better represent message origination time
                  maximum count on JavaScript 'working' status (periods)
                  identify and make available any HTML content in a non-MIME
                    message or in MIME text/plain in-line content
                  add [disk-quota-percent] and [vms-occlude] config directives
                  add [sig-file] user option directive
                  remove the [check-new-mail-nonajax] and [check-new-mail-MSIE]
                    user option directives and associated kludges
                  SearchPage()  results every "all hit(s)"
                  bugfix; AddressListMassage() better VMS address detection
                  bugfix; CallMailMessageList() restore from temporary
                    'MessageContext' when searching
                  bugfix; HtmlSkipTagTo() quotes outside of tags
                  bugfix; contact import and merge not broken but brain-dead
                    revision of ContactsImportLdif() and ContactsMergeLdif()
                  bugfix; ContactsLoadFile() do not munge non-personal (i.e.
                    site-specific) contact file name
06-MAY-2006  MGD  v1.1.1,
                  MessageHeader() show reply-to: field when different to from:
                  ComposePageRequest() reply-to/all to reply-to: if available
                    otherwise to from: 
                  MtaMsgSmtpToServer() allow a port number to be specified
                    with the SMTP server host (i.e. "the.host.name:25")
                  optimise CallMailMessageHeader() by completely replacing
                    mail$message_get() with mail$message_info() and adding
                    mail$message_get() to CallMailMessageGet() for non-external
                    mail messages only (suggested by Dave Jones)
                  accessability option [accessability-1]
                  bugfix; AddressIsRfc() RFC2822 only allows the double
                    quotation character (0x34) to quote
                  bugfix; AddressIsRfc() and MtaAddressExtract() allow
                    backslash (0x92) to escape a single character 
                  bugfix; PublicMessageRequest() detect [search] button
                  bugfix; ContactsLoadFile() rdptr->ContactsTextPtr = NULL
                    so that empty LDIF file is not confused with VMS list
                  bugfix; CallMailFileList() parsing of directory entry
                    name length and entry flags (per Dave Jones) and
                    use memmove() for shuffling inside the one buffer
18-APR-2006  MGD  v1.1.0, 
                  add configuration directive [private-request] and modify
                    behaviour to determine private or public access
                  add configuration directive [update-last-login] with
                    RequestLastLogin() optionally sets private access
                    SYSUAF last-login at first (initial GET) access 
                  bugfix; ComposeSelfAddress() size for calloc()
                  bugfix; RequestPublic() parsing folder with GET
09-APR-2006  MGD  v1.0.0,
                  add [send-close] and ComposeSendClose()
                  significant rework to rationalise public and private
                  remove default MAIL and NEWMAIL folders in listings
                  MessagePage() and PublicMessagePage() precede each
                    message part/attachment with an anchor/link to allow
                    for right-click browser save-as 
                  LangLoad() in conjunction with LANGDEF.H used to provide
                    details on missing/extra entries in a language file
                  ConfigPublicAccess() support wildcard folder mapping
                    in conjunction with extensive changes to PUBLIC.C
                  bugfix; OptionsSoyMail() propagation of personal
                    you-got-mail when when changing language option
                  bugfix; CerealDataOut() allow ambit 3x buffer space
27-MAR-2006  MGD  v0.4.3,
                  [wrap-text-at] transmogrified to [massage-read]
                    option now wraps long lines, eliminates extra line breaks
                    and removes any PGP signature
                  MessagePgpSigned() and MessagePgpCut() for PGP signature
                  small accomodation for Purveyor around 'binary' fwrite()s
                  RequestPrivate() Purveyor (1.2 at least) requires a full
                    URL to redirect (during logout)
                  refine 'watch' detail including MTA SMTP identification
                  'checking for new mail' uses beginWorking() progress dots
19-MAR-2006  MGD  v0.4.2,
                  AttachFile() ensure any file system path is stripped
                    from the attachment name before saving (MSIE)
                  refine HtmlNumericDeEntify() and HtmlCharacterDeEntify()
                  LangSame() modify comparison so that the message can
                    contain HTML entities useful in some buttons (e.g. &#10;)
                  AddressListMassage() refine address reduction (yep - again!)
                    also allow for appending a default host/domain if the
                    configuration directive [SMTP-defaulthost] is set
                  configuration directive [logout-realm] added to allow logout
                     for Apache (must be set the same as 'AuthName')
                  MimeDec8bit() disable reporting and always return OK
                  refine contact management wrt duplicate common names
                  bugfix; InetMailParseHeader() non-MIME MIME-like headers
                  bugfix; ContactsSave() to empty LDIF file
                  bugfix; MessageBodyIdentify() when generating plain from
                    HTML-only content call MimeDecProcessPart() to decode
                  bugfix; MessageBodyIdentify() default a non-MIME message
                    message to 8-bit, plain-text
13-MAR-2006  MGD  v0.4.1,
                  HtmlSanitise() suppress "background-image"
                  bugfix; ComposeSelfAddress() 'len' initialization
12-MAR-2006  MGD  v0.4.0,
                  MimeDecParseBody() return FALSE on detectable parse error
                    while all callers of this function check return and 
                    process on success or failure of the parse
                  MimeDecParseError() to report MIME parse problems
                  move input focus to the field most appropriate to the stage
                    of message composition, defaulting to the message text
                  remove 'noisy' message count from [message] range button
                  RequestPrivate() no longer include the username when
                    generating the form action URI unless POSTMASTER
                    facility in use (this reduces the leakage of potentially
                    sensitive information through the "Referer:.." header)
                  bugfix; RequestPrivate() do not upper-case username when
                    parsing path as it can interfere with VMS external auth
                  bugfix; ComposeSelfAddress() with rationalization of 'self' 
                    address generation and using this for the "From:" header
                  bugfix; allow MIME related headers (e.g. "Content-type:")
                    to precede the "MIME-version:" header (but cancel MIME
                    if it is not ultimately found in the message header)
04-MAR-2006  MGD  v0.3.9,
                  MessagePage() add MessageButtons() after longer messages
                  bugfix; CgiLibEnvironmentInit() for VMS Apache V2.n
                    and later (as with Apache V1.n) freopen("mrs=16384")
27-FEB-2006  MGD  v0.3.8,
                  ComposePageRequest() support VMS copy-send/forward/reply
                  CallMailGoToNewMail() if the new message count differs
                    from the messages selected count then adjust it
                  ComposeSendMessage() expand MX_.. logical names that
                    can be used to generate the "From:" address
                  ComposePage() [signature] button only if the user has a
                    signature file specified
                  RequestPrivate() refine [logout] mechanism to improve
                    overall behaviour and avoid hole if MSIE [cancel]s
                  [logout] now has associated JavaScript confirm explaining 
                    the logout basics and allowing an opportunity to cancel
                  [close] now has a JavaScript confirm for compose page
                  configuration directive [greeting] added to allow an
                    initial site-specific message shown in the status panel
                  OptionsWithinReason() make default OPTIONS_READ_PLAIN1_HTML2
                  refine MessageBodyIdentify() to manufacture plain-text
                    content when there is only HTML content
                  bugfix; MainMenuRequest() FOLDER_LIST_CHANGE detect 't'
                  bugfix; CallMailMessageDelete() close mail file to
                    empty WASTEBASKET before continuing request
                  bugfix; CallMailMessageCopyMove() adjust new message
                    count regardless of whether it's a copy or a move
16-FEB-2006  MGD  v0.3.7,
                  when used from the message page the main menu [compose]
                    button should provide a blank message, when used from the
                    compose page it should propagate any in-composition message
                  main menu [close] button for child windows
                  AddressListMassage() refine "<address>, <address>" reduction
                  provide more informative message if CallMailGetUserProfile()
                    reports MAIL$_NOSUCHUSER because of no profile entry
                  bugfix; MimeDecProcessPart() sanity check on pointer
                    not length (after all you can have empty content)
                  bugfix; ContactsEdit() no sanity check on un-specified
                    contact, just memset() zero it and continue as 'new' entry
12-FEB-2006  MGD  v0.3.6
                  optional folder buttons on left-side of message listing
                  support saving message as "message/rfc822" 'attachment'
                  refine MimeDecParseBody() to accomodate "message/rfc822"
                    attachments and any such internal MIME parts
                  modified [reply-to] option to [smtp-from] and in conjunction
                    with [personal-name] have ComposePageRequest() generate a
                    "From:" header more in line with TCPIP$SMTP_FROM behaviour
                  add explicit [reply-to] button and field so that messages
                    can individually have a reply-to set against them
                  ComposeMime() add client traceability information to
                    "Received:" header field
                  bugfix; default charset should be ISO-8859-1 not IS0-8859-1
                  bugfix; AttachComposeList() attachment size calculation
                  bugfix; RequestParsePath() attachment names can contain '/'
                  bugfix; SearchKeyword() lower-case the keyword!
27-JAN-2006  MGD  v0.3.5
                  initial public BETA release
01-FEB-2005  MGD  development commences
*/
/*****************************************************************************/

#define COPYRIGHT_DATE "2005-2007"
#define SOFTWAREVN "1.3.2"
#define SOFTWARENM "SOYMAIL"
#ifdef __ALPHA
#  define SOFTWAREID SOFTWARENM " AXP-" SOFTWAREVN
#endif
#ifdef __ia64
#  define SOFTWAREID SOFTWARENM " IA64-" SOFTWAREVN
#endif
#ifdef __VAX
#  define SOFTWAREID SOFTWARENM " VAX-" SOFTWAREVN
#endif
#define SOFTWARECR "Copyright (C) 2005-2007 Mark G.Daniel"

#ifdef SOYMAIL_VMS_V6
#undef _VMS_V6_SOURCE
#define _VMS_V6_SOURCE
#undef __VMS_VER
#define __VMS_VER 60000000
#undef __CRTL_VER
#define __CRTL_VER 60000000
#endif

#ifndef __VAX
#   pragma nomember_alignment
#endif

/* standard C header files */
#include <ctype.h>
#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* VMS related header files */
#include <descrip.h>
#include <lib$routines.h>
#include <prvdef.h>
#include <ssdef.h>
#include <stsdef.h>

/* application specific */
#include "soymail.h"
#include "cereal.h"
#include "callmail.h"
#include "cgilib.h"
#include "config.h"
#include "login.h"
#include "mainmenu.h"
#include "mta.h"
#include "other.h"
#include "request.h"
#include "message.h"

#define FI_LI __FILE__, __LINE__

/******************/
/* global storage */
/******************/

BOOL  Debug,
      IsCgiPlus,
      WatchEnabled;

int  VmsVersion;

unsigned long  CurrentVmsBinTime [2];
unsigned short  CurrentVmsNumTime [7];

char  *CgiEnvironmentPtr,
      *CgiRequestUriPtr,
      *SoyMailStatusPtr,
      *SoyMailScriptPath = "/soymail/-/";

char  CopyrightDate [] = COPYRIGHT_DATE,
      SoftwareCopy [] = SOFTWARECR,
      SoftwareId [] = SOFTWAREID,
      SoftwareVn [] = SOFTWAREVN,
      Utility [] = "SOYMAIL";

char  CommandLine [256],
      CurrentVmsTimeString [48],
      LocalHostName [128],
      SoftwareEnv [96];

USER_OPTIONS  UserOptions;
REQUEST_DATA  RequestData;
VMS_MAIL_USER  VmsMailUser;

/********************/  
/* external storage */
/********************/  

extern  CONFIG_DATA SoyMailConfig;

/**************/
/* prototypes */
/**************/

int sys$gettim (__unknown_params);
int sys$numtim (__unknown_params);

/*****************************************************************************/
/*
*/

main (int argc, char* argv[])
       
{
   int  status;
   VMS_MAIL_MSG  MailMsg;
   VMS_MAIL_USER  UserData;

   /*********/
   /* begin */
   /*********/

   StatTimer (FALSE);

   sprintf (SoftwareEnv, "%s, %s, %s",
            SOFTWAREID, (char*)CgiLibEnvironmentVersion(), BUILD_DATETIME);

   if (getenv ("SOYMAIL$DBUG"))
   {
      /* some contortions to accomodate OSU */
      Debug = TRUE;
      if (!getenv ("WWWEXEC_RUNDOWN_STRING"))
      {
         fprintf (stdout,
"Content-Type: text/plain\nScript-Control: X-content-encoding-gzip=0\n\n");
         CgiLibEnvironmentSetDebug (1);
      }
   }

   CgiLibEnvironmentInit (argc, argv, TRUE);
   if (Debug) CgiLibEnvironmentRecordOut ();

   if (CgiLibEnvironmentIsPurveyor())
   {
      fprintf (stdout, "%%%s-E-PURVEYOR, not supported!\n", Utility);
      exit (STS$K_ERROR | STS$M_INHIB_MSG);
   }

   if (Debug)
   {
      /* continuing contortions */
      if (getenv ("WWWEXEC_RUNDOWN_STRING"))
      {
         fprintf (stdout, "Content-Type: text/plain\n\n");
         CgiLibEnvironmentSetDebug (0);
      }
   }

   GetParameters (argc, argv);

   CgiLibResponseSetSoftwareID (SoftwareId);
   CgiLibResponseSetErrorStatus (403);
   CgiLibResponseSetErrorMessage ("reported by soyMAIL");

   CgiEnvironmentPtr = CgiLibEnvironmentName ();
   VmsVersion = GetVmsVersion ();

   ProcessRequest ();
}

/****************************************************************************/
/*
*/ 

ProcessRequest ()

{
   int gethostname (char*, int);

   int  PostBufferCount;
   char  *cptr, *sptr, *zptr,
         *PostBufferPtr;
   REQUEST_DATA  *rdptr;

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "ProcessRequest()\n");

   if (cptr = TrnLnm ("SOYMAIL$WATCH", NULL, 0))
   {
      if (Debug) fprintf (stdout, "SOYMAIL$WATCH |%s|\n", cptr);
      WatchEnabled = TRUE;
      if (isdigit(*cptr))
      {
         /* if it doesn't match the remote address then disable again */
         if (!(sptr = CgiVar ("REMOTE_ADDR"))) sptr = "";
         if (strcmp (cptr, sptr)) WatchEnabled = 0;
      }
   }

   if (Debug) WatchEnabled = TRUE;

   if (WatchEnabled)
   {
      /* initialize watch mode */
      WatchThis (NULL);
      WatchThis ("SYSTEM !AZ", GetPlatformDescription());
      cptr = CgiLibVarNull ("SERVER_SOFTWARE");
      if (!cptr) cptr = "?";
      WatchThis ("SERVER !AZ", cptr);
      WatchThis ("!AZ", SoftwareId);
      cptr = CgiLibVarNull ("HTTP_USER_AGENT");
      if (!cptr) cptr = "?";
      WatchThis ("AGENT !AZ", cptr);
   }

   sys$gettim (&CurrentVmsBinTime);
   sys$numtim (&CurrentVmsNumTime, &CurrentVmsBinTime);
   PrintFao (CurrentVmsTimeString, sizeof(CurrentVmsTimeString),
             "!20%D", &CurrentVmsBinTime);

   rdptr = &RequestData;

   /* reset this to empty, it'll be set "Set-Cookie:.." if needed */
   rdptr->LoginSetCookiePtr = "";

   /* some of these will be used during configuration so get 'em now */
   CGIVAR (rdptr->CgiRequestMethodPtr, "REQUEST_METHOD");
   CGIVAR (rdptr->CgiRequestUriPtr, "REQUEST_URI");
   CGIVAR (rdptr->CgiScriptNamePtr, "SCRIPT_NAME");
   CGIVAR (rdptr->CgiPathInfoPtr, "PATH_INFO");
   CGIVAR (rdptr->CgiQueryStringPtr, "QUERY_STRING");

   CGIVAR (rdptr->CgiHttpUserAgentPtr, "HTTP_USER_AGENT");
   if (strstr (rdptr->CgiHttpUserAgentPtr, "MSIE"))
      rdptr->UserAgent = SOY_USER_AGENT_MSIE;
   else
   if (strstr (rdptr->CgiHttpUserAgentPtr, "Mozilla"))
      rdptr->UserAgent = SOY_USER_AGENT_MOZILLA;
   else
   if (strstr (rdptr->CgiHttpUserAgentPtr, "Opera"))
      rdptr->UserAgent = SOY_USER_AGENT_OPERA;
   else
      rdptr->UserAgent = SOY_USER_AGENT_UNSPECIFIED;

   /* load the soyMAIL configuration */
   ConfigLoad (rdptr);

   if (SoyMailConfig.DowntimeMessage)
   {
      CgiLibResponseHeader (503, "text/html");
      fprintf (stdout, "%s &nbsp;&nbsp;&mdash;&nbsp;&nbsp %s\n",
               InetMailRfcVmsDate(CurrentVmsTimeString),
               SoyMailConfig.DowntimeMessage);
      return;
   }

   /* SMTP server identification (must be done after the configuration load) */
   if (WatchEnabled) MtaSmtpServerPoll (SoyMailConfig.SmtpServerHost);

   if (rdptr->CgiQueryStringPtr[0])
   {
      cptr = rdptr->CgiQueryStringPtr;
      if (!strcmp (cptr, "help") || !strncmp (cptr, "help+", 5))
      {
         /* public access to the consolidated help page */
         OptionsPublicGet (rdptr);

         cptr += 4;
         if (*cptr == '+')
         {
            cptr++;
            zptr = (sptr = rdptr->UserOptions.Language) +
                   sizeof(rdptr->UserOptions.Language)-1;
            while (*cptr && sptr < zptr) *sptr++ = *cptr++;
            *sptr = '\0';
         }

         LangLoad (rdptr->UserOptions.Language);
         if (!rdptr->UserOptions.CharSet[0])
            strcpy (rdptr->UserOptions.CharSet, LangFor("lang_charset"));

         HelpAll (rdptr);
         return; 
      }
   }

   if (!strcmp (rdptr->CgiRequestMethodPtr, "POST"))
   {
      /********/
      /* POST */
      /********/

      /* read and create the CGI variable equivalents of the body fields */
      CgiLibReadRequestBody (&PostBufferPtr, &PostBufferCount);
      if (WatchEnabled) WatchThis ("POST !UL bytes", PostBufferCount);
      if (!PostBufferPtr || !PostBufferCount)
      {
         ErrorExit (SS$_BUGCHECK, FI_LI);
         return;
      }
      if (WatchEnabled)
         WatchThis ("BODY !UL bytes\n!AZ", PostBufferCount, PostBufferPtr);
      CgiLibFormRequestBody (PostBufferPtr, PostBufferCount);
      if (WatchEnabled)
         while ((cptr = CgiLibVarNull ("*")) != NULL)
            WatchThis ("!AZ", cptr);
      /* now we can start to use the FORM_.. variables */
   }
   else
   {
      /*******/
      /* GET */
      /*******/

      PostBufferPtr = NULL;
      PostBufferCount = 0;
   }

   CGIVARNULL (cptr, "FORM_CLIENT_JAVASCRIPT");
   if (cptr) rdptr->ClientHasJavaScript = TRUE;

   if (gethostname (LocalHostName, sizeof(LocalHostName)) != 0)
      strcpy (LocalHostName, "unknown");

   if (SoyMailConfig.LoginSecret)
   {
      /* using soyMAIL's autogenous authentication */
      if (cptr = LoginVerifyUser (rdptr))
      {
         /* credentials did not verify */
         LoginPage (rdptr, cptr, PostBufferPtr, PostBufferCount);
         return;
      }

      /******************************/
      /* see description in LOGIN.C */
      /******************************/

      CGIVARNULL (cptr, "FORM_LOGIN_BODY")
      if (cptr && *cptr)
      {
         /*****************************/
         /* what an almighty kludge!! */
         /*****************************/

         /* get the content-type from the original post */
         CGIVARNULL (sptr, "FORM_LOGIN_TYPE")
         if (!sptr) ErrorExit (SS$_BUGCHECK, FI_LI);
         if (strncmp (sptr, "multipart/form-data;", 20))
            ErrorExit (SS$_BUGCHECK, FI_LI);
         sptr += 20;

         /* going to replace this with a saved POST from the form field */
         free (PostBufferPtr);

         /* reset the current FORM_ variables using the for-soyMAIL kludge */
         CgiLib__VarList ("!FORM_", "", NULL);

         /* get the saved POST from the form field */
         PostBufferCount = CerealDataIn (cptr, NULL, 0);
         PostBufferPtr = calloc (1, PostBufferCount);
         if (!PostBufferPtr) ErrorExit (vaxc$errno, FI_LI);
         PostBufferCount = CerealDataIn (cptr, PostBufferPtr, PostBufferCount);
         if (WatchEnabled)
            WatchThis ("BODY !UL bytes\n!AZ", PostBufferCount, PostBufferPtr);

         /* now turn this saved post into form field variables */
         CgiLib__BodyMultipartFormData (PostBufferPtr, PostBufferCount, sptr);
         if (WatchEnabled)
            while ((cptr = CgiLibVarNull ("*")) != NULL)
               WatchThis ("!AZ", cptr);
      }
   }
   else
   {
      /* using HTTP authentication (via server configuration) */
      CGIVAR (cptr, "REMOTE_USER");
      rdptr->UserNameLength = strzcpy (rdptr->UserName, cptr,
                                       sizeof(rdptr->UserName));
      rdptr->RemoteUserLength = strzcpy (rdptr->RemoteUser, cptr,
                                         sizeof(rdptr->RemoteUser));
   }

   if (PostBufferPtr)
   {
      /* delayed cleanup due to potential use by LoginPage() */
      free (PostBufferPtr);
      PostBufferPtr = NULL;
      PostBufferCount = 0;
   }

   if (rdptr->PrivateAccess)
      RequestPrivate (rdptr);
   else
   if (rdptr->PublicAccess)
      RequestPublic (rdptr);
   else
      ErrorExit (SS$_BUGCHECK, FI_LI);

   /* reset watch mode as necessary */
   if (WatchEnabled) WatchThis (NULL);
}

/*****************************************************************************/
/*
Get "command-line" parameters, whether from the command-line or from a
configuration symbol or logical containing the equivalent.
*/

GetParameters
(
int argc,
char *argv[]
)
{
   static unsigned long  Flags = 0;

   int  status,
        SkipParameters;
   unsigned short  Length;
   char  ch;
   char  *aptr, *cptr, *clptr, *sptr;
   $DESCRIPTOR (CommandLineDsc, CommandLine);

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "GetParameters()\n");

   if ((clptr = getenv ("SOYMAIL$PARAM")) == NULL)
   {
      /* get the entire command line following the verb */
      status = lib$get_foreign (&CommandLineDsc, 0, &Length, &Flags);
      if (VMSnok (status)) exit (status);
      (clptr = CommandLine)[Length] = '\0';
   }

   /* the first is CSWS 1.2/1.3, the other two for SWS 2.0 */
   if (getenv ("APACHE$SHARED_SOCKET") != NULL ||
       getenv ("APACHE$PARENT_PID") != NULL ||
       getenv ("APACHE$SERVER_TAG") != NULL)
      SkipParameters = 99;
   else
   /* if OSU environment then skip P1, P2, P3 */
   if (getenv ("WWWEXEC_RUNDOWN_STRING") != NULL)
      SkipParameters = 3;
   else
      SkipParameters = 0;

   aptr = NULL;
   ch = *clptr;
   for (;;)
   {
      if (aptr != NULL && *aptr == '/') *aptr = '\0';
      if (!ch) break;

      *clptr = ch;
      if (Debug) fprintf (stdout, "clptr |%s|\n", clptr);
      while (*clptr && isspace(*clptr)) *clptr++ = '\0';
      aptr = clptr;
      if (*clptr == '/') clptr++;
      while (*clptr && !isspace (*clptr) && *clptr != '/')
      {
         if (*clptr != '\"')
         {
            clptr++;
            continue;
         }
         cptr = clptr;
         clptr++;
         while (*clptr)
         {
            if (*clptr == '\"')
               if (*(clptr+1) == '\"')
                  clptr++;
               else
                  break;
            *cptr++ = *clptr++;
         }
         *cptr = '\0';
         if (*clptr) clptr++;
      }
      ch = *clptr;
      if (*clptr) *clptr = '\0';
      if (Debug) fprintf (stdout, "aptr |%s|\n", aptr);
      if (!*aptr) continue;

      if (SkipParameters)
      {
         /*
             Apache supplies query string keywords on the command line
             to a CGI script.  With Apache the command-line is ignored
             up until the /_APACHE qualifier triggers anything following
             to be processed.             
         */
         if (!strsame (aptr, "/_APACHE", -1))
         {
            SkipParameters--;
            continue;
         }
         SkipParameters = 0;
      }

      /***********/
      /* process */
      /***********/

      if (strsame (aptr, "/DBUG", -1))
      {
         Debug = TRUE;
         continue;
      }

      if (strsame (aptr, "/REGEX", -1))
      {
         /* kludgy, kludgy, kludgy! */
         SearchRegexCheck (clptr+1);
         exit (SS$_NORMAL);
      }

      if (*aptr == '/')
      {
         fprintf (stdout, "%%%s-E-IVQUAL, unrecognized qualifier\n \\%s\\\n",
                  Utility, aptr+1);
         exit (STS$K_ERROR | STS$M_INHIB_MSG);
      }

      fprintf (stdout, "%%%s-E-MAXPARM, too many parameters\n \\%s\\\n",
               Utility, aptr);
      exit (STS$K_ERROR | STS$M_INHIB_MSG);
   }
}

/*****************************************************************************/

